/**
 * Assertion.java
 *
 * File generated from the XValidator4::Assertion uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.UniqueConstraint;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.hql.FilterLabel;

import org.w3c.dom.Node;

/**
 * Description of the class Assertion.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "assertion", propOrder = { "assertionId", "idScheme" })
@XmlRootElement(name = "assertion")
@Entity
@Table(name = "xval_assertion", schema = "public")
@SequenceGenerator(name = "xval_assertion_sequence", sequenceName = "xval_assertion_id_seq", allocationSize = 1)
public class Assertion implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = -7133083767210692758L;

	@Id
	@Column(name = "id", unique = true, nullable = false)
	@GeneratedValue(generator = "xval_assertion_sequence", strategy = GenerationType.SEQUENCE)
	@XmlTransient
	private Integer id;

	@XmlAttribute(name = "assertionId", required = true)
	@Column(name = "assertion_id", nullable = false)
	private String assertionId;

    @Transient
    @XmlTransient
    private String description;

	@XmlAttribute(name = "idScheme", required = true)
	@Column(name = "id_scheme", nullable = false)
	private String idScheme;

	@XmlTransient
	@ManyToMany(targetEntity = Rule.class)
	@JoinTable(name = "xval_assertion_rule", joinColumns = @JoinColumn(name = "assertion_id"), inverseJoinColumns = @JoinColumn(name = "rule_id"), uniqueConstraints = @UniqueConstraint(columnNames = {
			"assertion_id", "rule_id" }))
	private List<Rule> rules;
	
	public Assertion() {
		
	}

    public Assertion(String idScheme, String assertionId, String description){
        this.idScheme = idScheme;
        this.assertionId = assertionId;
        this.description = description;
    }
	
	public Assertion(Assertion assertion){
		this.assertionId = assertion.getAssertionId();
		this.idScheme = assertion.getIdScheme();
	}

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	@FilterLabel
	public String getLabel() {
		StringBuilder label = new StringBuilder(this.assertionId);
		label.append(" (");
		label.append(this.idScheme);
		label.append(')');
		return label.toString();
	}

	/**
	 * Return assertionId.
	 *
	 * @return assertionId
	 */
	public String getAssertionId() {
		return assertionId;
	}

	/**
	 * Set a value to attribute assertionId.
	 *
	 * @param assertionId
	 *            .
	 */
	public void setAssertionId(String assertionId) {
		this.assertionId = assertionId;
	}

	/**
	 * Return idScheme.
	 *
	 * @return idScheme
	 */
	public String getIdScheme() {
		return idScheme;
	}

	/**
	 * Set a value to attribute idScheme.
	 *
	 * @param idScheme
	 *            .
	 */
	public void setIdScheme(String idScheme) {
		this.idScheme = idScheme;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "assertion", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public List<Rule> getRules() {
		if (rules == null) {
			rules = new ArrayList<Rule>();
		}
		return rules;
	}

	public void setRules(List<Rule> rules) {
		this.rules = rules;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((assertionId == null) ? 0 : assertionId.hashCode());
		result = (prime * result) + ((idScheme == null) ? 0 : idScheme.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Assertion other = (Assertion) obj;
		if (assertionId == null) {
			if (other.assertionId != null) {
				return false;
			}
		} else if (!assertionId.equals(other.assertionId)) {
			return false;
		}
		if (idScheme == null) {
			if (other.idScheme != null) {
				return false;
			}
		} else if (!idScheme.equals(other.idScheme)) {
			return false;
		}
		return true;
	}

	public void addRule(Rule newRule) {
		if (!getRules().contains(newRule)) {
			this.getRules().add(newRule);
		}
	}

	public void removeRule(Rule rule) {
		this.getRules().remove(rule);
	}

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}